package org.vrablik.test.infinispan.cluster.hotrod;

import java.sql.Timestamp;
import java.util.Random;

import org.infinispan.Cache;
import org.infinispan.client.hotrod.RemoteCacheManager;
import org.infinispan.manager.CacheContainer;

public class DistributedDirectoryHotRod {
    public static void main(String[] args){
    String serverIpAddress = "192.168.0.102";
    if (args.length >= 1 && args[0] != null){
        serverIpAddress = args[0];
    }
    System.out.println("server ip address " + serverIpAddress);
    
    int port = 11222;
    if (args.length >= 2 && args[1] != null){
        port = Integer.parseInt(args[1]);
    }
    System.out.println("server port: " + port);
    
    CacheContainer cacheContainer = new RemoteCacheManager(serverIpAddress,port);
    //obtain a handle to the remote default cache
    Cache<String, Car> cache = cacheContainer.getCache();
    Car newCar = new Car(new Timestamp(System.currentTimeMillis()), "zdenek", "ferrari1");
    
    
    int size = new Random().nextInt(10) + 40 * 1024 * 1024;
    int[] carData = new int[size]; 
    for ( int i=0; i < size; i++){
      carData[i]=i;   
    }
    newCar.setCarData(carData);
    
    long estimate = new MemoryCounter().estimate(newCar);
    System.out.println("NewCar size in MB: " + ( estimate * 1.0 / (1024*1024)) );
    
    System.out.println("before get \t" + new Timestamp(System.currentTimeMillis()));
    Car carFromCache = cache.get("car");
    System.out.println("after get \t" + new Timestamp(System.currentTimeMillis()));
  //now add something to the cache and make sure it is there
  if ( carFromCache == null || carFromCache.getCarDataLength() != newCar.getCarDataLength()){
    System.out.println("before put \t" + new Timestamp(System.currentTimeMillis()));
    cache.put("car", newCar);
    System.out.println("after put \t" + new Timestamp(System.currentTimeMillis()));
  }
  
   
  System.out.println("before get \t" + new Timestamp(System.currentTimeMillis()));
  Car carFromCache2 = cache.get("car");
  System.out.println("after get \t" + new Timestamp(System.currentTimeMillis()));
  System.out.println("should be car : \t" + carFromCache2);
   }
}
