package org.vrablik.test.infinispan.embedded;

import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;

public class EmbeddedApp {
  
  public static void main(String args[]) throws Exception {
    Cache<Object, Object> cache = new DefaultCacheManager().getCache();
    
    // Add a entry
    cache.put("key", "value");
    // Validate the entry is now in the cache
    System.out.println("cache size (should be 1): " + cache.size());
    System.out.println("cache should contain key: " + cache.containsKey("key"));
    // Remove the entry from the cache
    Object v = cache.remove("key");
    // Validate the entry is no longer in the cache
    System.out.println("cache value should be value: " + v);
    System.out.println("cache should be empty: " + cache.isEmpty());
  }
}
